package disks

import (
	"context"

	"github.com/hashicorp/terraform-plugin-sdk/v2/helper/schema"
	log "github.com/sirupsen/logrus"
	"repository.basistech.ru/BASIS/decort-golang-sdk/pkg/cloudapi/disks"
	"repository.basistech.ru/BASIS/terraform-provider-decort/internal/controller"
)

func utilityDiskListUnattachedCheckPresence(ctx context.Context, d *schema.ResourceData, m interface{}) (disks.ListDisksUnattached, error) {
	c := m.(*controller.ControllerCfg)
	req := disks.ListUnattachedRequest{}
	if accountId, ok := d.GetOk("accountId"); ok {
		req.AccountID = uint64(accountId.(int))
	}

	log.Debugf("utilityDiskListUnattachedCheckPresence: load disk Unattached list")
	unattachedList, err := c.CloudAPI().Disks().ListUnattached(ctx, req)
	if err != nil {
		return nil, err
	}

	return unattachedList, nil
}
