package image

import (
	"context"

	"github.com/hashicorp/terraform-plugin-sdk/v2/helper/schema"
	"repository.basistech.ru/BASIS/decort-golang-sdk/pkg/cloudapi/account"
	"repository.basistech.ru/BASIS/decort-golang-sdk/pkg/cloudapi/locations"
	"repository.basistech.ru/BASIS/terraform-provider-decort/internal/controller"
)

func existAccountID(ctx context.Context, d *schema.ResourceData, m interface{}) (bool, error) {
	c := m.(*controller.ControllerCfg)
	accountId := uint64(d.Get("account_id").(int))
	req := account.ListRequest{}

	accounts, err := c.CloudAPI().Account().List(ctx, req)
	if err != nil {
		return false, err
	}

	return len(accounts.FilterByID(accountId)) != 0, nil
}

func existGID(ctx context.Context, d *schema.ResourceData, m interface{}) (bool, error) {
	c := m.(*controller.ControllerCfg)
	gid := uint64(d.Get("gid").(int))
	req := locations.ListRequest{}

	locationList, err := c.CloudAPI().Locations().List(ctx, req)
	if err != nil {
		return false, err
	}

	return len(locationList.FilterByGID(gid)) != 0, nil
}
