#Расскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    decort = {
      source = "basis/decort/decort"
      version = "<VERSION>"
    }
  }
}
*/

provider "decort" {
  authenticator  = "oauth2"
  oauth2_url     = "https://sso.digitalenergy.online"
  controller_url = "https://mr4.digitalenergy.online"
  app_id         = ""
  app_secret     = ""
}

resource "decort_image" "img" {
  # Наименование образа
  # Обязательный параметр
  # string
  name = "image_name"

  # grid ID платформы
  # Обязательный параметр
  # int
  gid = 2002

  # Драйверы компьютов, подходящие для данного образа
  # Обязательный параметр
  # []string
  drivers = ["KVM_X86"]

  # Тип образа (linux, windows и др.)
  # Обязательный параметр
  # string
  type = "linux"

  # Прямая ссылка на образ
  # Обязательный параметр
  # string
  url = "https://dl-cdn.alpinelinux.org/alpine/v3.17/releases/x86_64/alpine-virt-3.17.3-x86_64.iso"

  # Тип загрузчика (bios/uefi)
  # Обязательный параметр
  # string
  boot_type = "bios"

  # ID аккаунта
  # Опциональный параметр
  # int
  account_id = 138

  # Поддержка hot resize
  # Опциональный параметр
  # bool
  hot_resize = true

  # Юзернейм для образа
  # Опциональный параметр
  # string
  username = "userx"

  # Пароль для образа
  # Опциональный параметр
  # string
  password = "passx"

  # Юзернейм для загрузки binary media
  # Опциональный параметр
  # string
  username_dl = "userxdl"

  # Пароль для загрузки binary media
  # Опциональный параметр
  # string
  password_dl = "passxdl"

  # Storage endpoint provider ID
  # Опциональный параметр
  # int
  sep_id = 1

  # Pool для образа
  # Опциональный параметр
  # string
  pool_name = "pool"

  # Архитектура обраща (X86_64 / PPC64_LE)
  # Опциональный параметр
  # string
  architecture = "PPC64_LE"
}

output "img_out" {
  value = decort_image.img
}
